#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

bool check(vector<int> &arr) {
    for (int i = 0; i < arr.size(); ++i)
        if (arr[i] == i + 1)
        return false;
    return true;
}

void Solve1(int n){
    vector<int> arr(10 - n % 2);
    for (int i = 0; i < arr.size(); ++i)
        arr[i] = i + 1;

    int t;
    cin >> t;
    while (t){
        if (check(arr)){
            for (int i = 0; i < n - arr.size(); ++i){
                if (i % 2 == 0){
                    cout << i + 2 << " ";
                }
                else{
                    cout << i << " ";
                }
            }
            for (int j = 0; j < arr.size(); ++j)
                cout << arr[j] + n - arr.size() << " ";
            cout << endl;
            --t;
        }
        next_permutation(arr.begin(), arr.end());
    }
}

void Solve2(int n){
    vector<int> arr(n);
    for (int i = 0; i < n; ++i)
        arr[i] = i + 1;

    int t;
    cin >> t;
    while (t){
        if (check(arr)){
            for (int j = 0; j < arr.size(); ++j)
                cout << arr[j] << " ";
            cout << endl;
            --t;
        }
        next_permutation(arr.begin(), arr.end());
    }
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n;
    cin >> n;
    if (n >= 10){
        Solve1(n);
    }
    else{
        Solve2(n);
    }
    return 0;
}
