#include <iostream>
#include <vector>
#include <string>

using namespace std;

bool check(){
    int k, n;
    cin >> k >> n;

    vector< vector<char> > used(k, vector<char>(k));

    for (int i = 0; i < n; ++i){
        char c1, c2;
        cin >> c1 >> c2;
        c1 -= 'a';
        c2 -= 'a';

        used[c1][c2] = true;
        used[c2][c1] = true;
    }

    string s1, s2;
    cin >> s1 >> s2;

    vector< vector<int> > pref1(k, vector<int>(s1.size() + 1));
    for (int i = 0; i < k; ++i)
        for (int j = 1; j <= s1.size(); ++j)
            pref1[i][j] = pref1[i][j - 1] + (s1[j - 1] - 'a' == i);

    vector< vector<int> > pref2(k, vector<int>(s2.size() + 1));
    for (int i = 0; i < k; ++i)
        for (int j = 1; j <= s2.size(); ++j)
            pref2[i][j] = pref2[i][j - 1] + (s2[j - 1] - 'a' == i);

    vector< vector<int> > arr1(k);
    for (int i = 0; i < s1.size(); ++i)
        arr1[s1[i] - 'a'].push_back(i);

    vector< vector<int> > arr2(k);
    for (int i = 0; i < s2.size(); ++i)
        arr2[s2[i] - 'a'].push_back(i);

    for (int c = 0; c < k; ++c){
        if (arr1[c].size() != arr2[c].size()){
            return false;
        }

        for (int i = 0; i < arr1[c].size(); ++i){
            for (int j = 0; j < k; ++j){
                if (!used[c][j] && pref1[j][arr1[c][i] + 1] != pref2[j][arr2[c][i] + 1]){
                    return false;
                }
            }
        }
    }

    return true;
}
/*
3 2
ab
bc
abbcabc
abcacbb
*/

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    if (check()){
        cout << "YES" << endl;
    }
    else{
        cout << "NO" << endl;
    }

    return 0;
}
