#include <iostream>
#include <map>
#include <string>
#include <vector>
#include "math.h"

using namespace std;


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    long long n, k;
    cin >> k >> n;
    char a, b;
    map<pair<char, char>, short> arr;
    vector<int> c1(k);
    vector<int> c2(k);
    for (int i = 0; i < n; i++) {
        cin >> a >> b;
        arr[{a, b}] = 1;
    }
    string s1, s2;
    cin >> s1;
    cin >> s2;
    for (int i = 0; i < s1.length(); i++) {
        c1[s1[i] - 'a']++;
        c2[s2[i] - 'a']++;
    }
    for (int i = 0; i < k; i++) {
        if (c1[i] != c2[i]) {
            cout << "NO";
            exit(0);
        }
    }
    int count11, count12, count21, count22 = 0;
    for (int p = 0; p < k; p++) {
        for (int u = p + 1; u < k; u++) {
            a = char('a' + p);
            b = char('a' + u);
            if (arr[{a, b}] == 0) {
                count11 = count12 = count21 = count22 = 0;
                for (int i = 0; i < s1.length(); i++) {
                    if (s1[i] == a)
                        count11++;
                    if (s2[i] == a)
                        count21++;
                    if (s1[i] == b)
                        count12++;
                    if (s2[i] == b)
                        count22++;
                    //cout << count12 - count11 << " " << count22 - count11 << endl;
                    if (abs(count12 - count11 - (count22 - count21)) > 1) {
                        cout << "NO";
                        exit(0);
                    }
                }
            }
        }
    }
    cout << "YES";
    return 0;
}