#include <iostream>
using namespace std;

long long *a, t[4 * 500000];
long long INF = 2e18;

long long nod(long long a, long long b){
    if(a == INF)
        return b;
    else if(b == INF)
        return a;
    while(a != 0 && b != 0){
        if(a > b)
            a %= b;
        else
            b %= a;
    }
    return a + b;
}
void build(int v, int tl, int tr){
	if (tl == tr)
		t[v] = a[tl];
	else{
		int tm = (tl + tr) / 2;
		build(v*2, tl, tm);
		build(v*2+1, tm+1, tr);
		t[v] = nod(t[v*2], t[v*2+1]);
	}
}
long long nod(int v, int tl, int tr, int l, int r){
	if (l > r)
		return INF;
	if (l == tl && r == tr)
		return t[v];
	int tm = (tl + tr) / 2;
	return nod(nod(v*2, tl, tm, l, min(r,tm)),
        nod(v*2+1, tm+1, tr, max(l,tm+1), r));
}
int main(){
    int n, k;
    cin >> n >> k;
    a = new long long[n];
    for(int i=0; i<n; i++)
        cin >> a[i];
    build(1, 0, n - 1);
    //cout << "nod on first 3: " << nod(1, 0, n - 1, 0, 1) << endl;
    long long max_nod = 1;
    for(int i=0; i<n+1-k; i++){
        max_nod = max(max_nod, nod(1, 0, n - 1, i, i + k - 1));
    }
    cout << max_nod;
    return 0;
}
