#include <iostream>
#include <algorithm>
#include <math.h>

using namespace std;

long long get_gcd(long long a, long long b)
{
	long long c;

	while (b != 0)
	{
		c = b;
		b = a % b;
		a = c;
	}
	return a;
}

int main()
{
	ios::sync_with_stdio(0);
	const int SIZE = 5e4, LOG = 20;
	static long long sparse_t[LOG][SIZE], arr[SIZE], n, k, ans, k_log;

	cin >> n >> k;
	for (int i = 0; i < n; i++)
		cin >> arr[i];
	k_log = log2(k - 1);
	for (int i = 0; i < n; i++)
		sparse_t[0][i] = arr[i];
	for (int i = 1; i < LOG; i++)
		for (int j = 0; j <= n - (1 << i); j++)
			sparse_t[i][j] = get_gcd(sparse_t[i - 1][j], sparse_t[i - 1][j + (1 << (i - 1))]);
	for (int i = 0; i <= n - k; i++)
	{
		ans = max(ans, get_gcd(sparse_t[k_log][i], sparse_t[k_log][i + k - (1 << k_log)]));
	}
	cout << ans;
}