#include <iostream>
#include <vector>
#include <utility>

using namespace std;

long long gcd(long long a, long long b) {
    long long t;
    while(b != 0) {
        t = b;
        b = a % b;
        a = t;
    }
    return a;
}

int main() {
    int n, k; cin >> n >> k;
    vector<long long> v(n);
    for(int i = 0; i < n; i++) cin >> v[i];
    int m = 0;
    for(int i = 0; i < n-k; i++) {
        int g = gcd(v[i], v[i+1]);
        for(int j = 2; j < k; j++) {
            g = gcd(g, v[j+i]);
        }
        m = max(m, g);
    }
}