#include <iostream>
#include <vector>
#include <utility>

using namespace std;

long long gcd(long long a, long long b) {
    long long t;
    while(b != 0) {
        t = b;
        b = a % b;
        a = t;
    }
    return a;
}

int main() {
    int n, k; cin >> n >> k;
    vector<long long> v(n);
    for(int i = 0; i < n; i++) cin >> v[i];
    long long m = 0;
    for(long long i = 0; i <= n-k; i++) {
        long long g = v[i];
        for(long long j = 1; j < k; j++) {
            g = gcd(g, v[j+i]);
        }
        m = max(m, g);
    }
    std::cout << m;
}