import java.util.Scanner;
import static java.lang.Math.*;

public class TaskEGreatCommonDivider {
	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		int n,k;
		n = sc.nextInt();
		k = sc.nextInt();

		long[] nums = new long[n];
		for (int i = 0; i < n; i++) {
			nums[i] = sc.nextLong();
		}
		
		System.out.println(think(n,k,nums));
	}

	private static long think(int n, int k, long[] nums) {
		long res = 0;
		long cgcd = 0;
		for(int i = 0; i+k-1<n;i++){
			cgcd = nums[i];
			for (int j = i+1; j < i+k; j++) {
				cgcd = gcd(cgcd, nums[j]);
			}
			res = max(cgcd,res);
		}
		return res;
	}

	private static long gcd(long a, long b) {
		long r;
		while(true){
			r = b%a;
			if(r == 0)
				return a;
			b = a;
			a = r;
		}
	}

}
