#include <iostream>
#include <algorithm>
#include <sstream>
#include <vector>
#include <math.h>
#include <deque>
#include <string>

using namespace std;
#define li long long int
#define vec vector <li>
#define rep(n) for(li i = 0; i < n; i++)
#define pub push_back
#define sortv(myobject) sort(myobject.begin(), myobject.end())
#define sh(some) cout << some << endl

bool contains(string o, char d)
{
	for (li i = 0; i < o.size(); i++)
	{
		if (o[i] == d)
			return true;
	}
	return false;
}
vec contains(vec j, li o)
{
    vec u;
	rep(j.size())
	{
		if (j[i] == o)
			u.pub(i);
	}
	return u;
}
li cont(vec j, li o)
{
    vec u;
	rep(j.size())
	{
		if (j[i] == o)
			return i;
	}
	return -1;
}
li cont(vec j, li from, li o)
{
    vec u;
	for(li i = from; i < j.size(); i++)
	{
		if (j[i] == o)
			return i;
	}
	return -1;
}
string cut(string u, li st, li end)
{
	string r;
	while (st++ < end)
		r += u[st];
	return r;
}
bool isPrime (int num)
{
    if (num <=1)
        return false;
    else if (num == 2)
        return true;
    else if (num % 2 == 0)
        return false;
    else
    {
        bool prime = true;
        int divisor = 3;
        double num_d = static_cast<double>(num);
        int upperLimit = static_cast<int>(sqrt(num_d) +1);

        while (divisor <= upperLimit)
        {
            if (num % divisor == 0)
                prime = false;
            divisor +=2;
        }
        return prime;
    }
}
int gcd(int a, int b)
{
    for (;;)
    {
        if (a == 0) return b;
        b %= a;
        if (b == 0) return a;
        a %= b;
    }
}

int lcm(int a, int b)
{
    int temp = gcd(a, b);

    return temp ? (a / temp * b) : 0;
}
int scm(int a, int b, int c)
{
    return lcm(lcm(a, b), c);
}

int main()
{
    li n, k;
	cin >> n >> k;
	li * a = new li[n];
	rep(n)
		cin >> a[i];
	li ans = 0;
	
	
	for(li sel = 0; sel < n; sel++)
	{
		deque < deque<li> > d;
		deque <li> gcds;
		deque <li> one;
		one.push_back(sel);
		
		gcds.push_back(a[sel]);
		d.push_back(one);
		for(li i = 1; i < k; i++) {
			li prev = gcds[i - 1];
			li max_gcd = 0;
			li max_gcd_index = 0;
			
			li pf = 0;
			for(li q = 0; q < n; q++) {
				if(pf != n && d[i - 1][pf] == q) {
					pf++;
					continue;
				}
				li t = gcd(prev, a[q]);
				if(t > max_gcd) {
					max_gcd_index = q;
					max_gcd = t;
				}
			}
			gcds.push_back(max_gcd);
			
			deque <li> copy = d[i - 1];
			copy.push_back(max_gcd_index);
			sort(copy.begin(), copy.end());
			d.push_back(copy);
		}
		ans = max(ans, gcds[k-1]);
	}
	cout << ans << endl;
}
