#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <algorithm>
#include<fstream>
#include<unordered_set>

#define all(x) x.begin(), x.end()
#define ll long long
#define pb push_back

using namespace std;

const int maxn = 5 * 1e5;
const int maxlog = 21;

int n, k;

ll gcd(ll a, ll b) {
	while (b) {
		a %= b;
		swap(a, b);
	}
	return a;
}

ll ST[maxn][maxlog];
ll deg[21];
void build() {
	for (int i = 1; i < maxlog; i++) {
		for (int j = 0; j <= n - deg[i]; j++) {
			ST[i][j] = gcd(ST[i - 1][j], ST[i - 1][j + deg[i - 1]]);
		}
	}
}

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> k;
	deg[0] = 1;
	for (int i = 1; i < maxlog; i++) {
		deg[i] = deg[i - 1] * 2;
	}
	for (int i = 0; i < n; i++) {
		cin >> ST[0][i];
	}
	build();
	int q = 1;
	while (deg[q + 1] <= k)
		q++;
	ll ans = 0;
	for (int i = 0; i <= n - k; i++) {
		ans = max(ans, gcd(ST[q][i], ST[q][i + k - deg[q]]));
	}
	cout << ans;
	return 0;
}