import javafx.util.Pair;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.nio.channels.InterruptedByTimeoutException;
import java.util.*;

public class E {
    StringTokenizer st;
    BufferedReader br;
    PrintWriter pw;
    static long a[];

    private static long gcd(long a, long b) {
        long c = Math.max(a, b);
        long d = Math.min(a, b);
        while (c != 0 && d != 0) {
            c %= d;
            long t = d;
            d = c;
            c = t;
        }
        return c + d;
    }

    static class Sl {
        int l, r;
        long value;
        Sl left, right;

        public long build(Sl t, int l, int r) {
            t.l = l;
            t.r = r;
            if (l == r) {
                t.value = a[l];
                return a[l];
            }
            Sl tl = new Sl();
            Sl tr = new Sl();
            t.left = tl;
            t.right = tr;
            t.value = gcd(build(tl, l, (l + r) / 2), build(tr, 1 + (l + r) / 2, r));
            return t.value;
        }

        public long count(int l, int r) {
            if (this.l == l && this.r == r) {
                return this.value;
            }
            int mid = (this.l + this.r) / 2;
            if (r <= mid) {
                return this.left.count(l, r);
            } else if (l > mid) {
                return this.right.count(l, r);
            } else {
                return gcd(this.left.count(l, mid), this.right.count(mid + 1, r));
            }
        }
    }

    private void run() throws IOException {
        br = new BufferedReader(new InputStreamReader(System.in));
        pw = new PrintWriter(System.out);
        int n = nextInt();
        int k = nextInt();
        a = new long[n];
        for (int i = 0; i < n; i++) {
            a[i] = nextLong();
        }
        Sl nd = new Sl();
        nd.build(nd, 0, n - 1);
        long maxNd = 0;
        for (int i = 0; i <= n - k; i++) {
            maxNd = Math.max(maxNd, nd.count(i, i + k - 1));
        }

        pw.print(maxNd);
        pw.close();

    }

    public String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        new E().run();
    }

}
