#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;

long long gcd(long long a, long long b) {
	while (a && b) {
		if (a < b)
			swap(a, b);
		a %= b;
	}
	return a + b;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int n, k; cin >> n >> k;
	vector<long long> a(n);
	for (auto &x : a) {
		cin >> x;
	}
	vector<int> f(n + 1);
	for (int i = 2; i <= n; i++) {
		f[i] = f[i / 2] + 1;
	}
	vector<vector<long long>> s(n, vector<long long>(f[n] + 1));
	for (int i = n - 1; i >= 0; i--) {
		s[i][0] = a[i];
		for (int j = 1; j <= f[n]; j++) {
			int ind = i + (1 << (j - 1));
			s[i][j] = (ind >= n ? s[i][j - 1] : gcd(s[i][j - 1], s[ind][j - 1]));
		}
	}
	long long ans = 0;
	for (int i = 0; i < n - k + 1; i++) {
		int j = i + k - 1;
		int cur = f[k];
		ans = max(ans, gcd(s[i][cur], s[j - (1 << cur) + 1][cur]));
	}
	cout << ans << endl;
//	system("pause");
}