﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ProblemA
{
    class Program
    {
        static int v1 = 1;
        static int v2 = 0;
        static int x = 1000;
        static int y = 1000;
        static int minx = 1000;
        static int miny = 1000;
        static int maxx = 1000;
        static int maxy = 1000;
        static bool[,] field = new bool[2001, 2001];
        static int n;
        static int d;
        static int k;
        static int current = 0;
        static void Main(string[] args)
        {
            String[] s = Console.ReadLine().Trim().Split(' ');
            n = int.Parse(s[0]);
            d = int.Parse(s[1]);
            k = int.Parse(s[2]);
            field[1000, 1000] = true;
            Draw();
            Console.Write(maxy - miny + 1);
            Console.Write(" ");
            Console.Write(maxx - minx + 1);
            Console.WriteLine();
            for (int cy = miny; cy <= maxy; cy++)
            {
                for (int cx = minx; cx <= maxx; cx++)
                {
                    if (field[cx, cy])
                    {
                        Console.Write("*");
                    }
                    else
                    {
                        Console.Write(".");
                    }
                }
                Console.WriteLine();
            }
        }
        static void Draw()
        {
        loop:;
            LongForward();
            if (current == n)
            {
                goto stop;
            }
            Rotate();
            LongForward();
            if (current == n)
            {
                goto stop;
            }
            Rotate();
            d *= k;
            goto loop;
        stop:;
        }
        static void LongForward()
        {
            for (int i = 0; i < d; i++)
            {
                x += v1;
                y += v2;
                field[x, y] = true;
                if (x < minx)
                {
                    minx = x;
                }
                if (x > maxx)
                {
                    maxx = x;
                }
                if (y < miny)
                {
                    miny = y;
                }
                if (y > maxy)
                {
                    maxy = y;
                }
                current++;
                if (current == n)
                {
                    goto stop;
                }
            }
        stop:;
        }
        static void Rotate()
        {
            if (v1 == 1)
            {
                v2 = -1;
                v1 = 0;
                goto end;
            }
            if (v1 == -1)
            {
                v2 = 1;
                v1 = 0;
                goto end;
            }
            if (v2 == 1)
            {
                v1 = 1;
                v2 = 0;
                goto end;
            }
            if (v2 == -1)
            {
                v1 = -1;
                v2 = 0;
            }
        end:;
        }
    }
}
