#include <iostream>
#include <vector>
#include <string>

using namespace std;

bool InComm( char C1, char C2, const vector<string> &Comm)
{
  for (string S : Comm)
  {
    if (S[0] == C1 && S[1] == C2 || S[1] == C1 && S[0] == C2)
      return 1;
  }
  return 0;
}

int main( void )
{
  int k, n;
  vector<string> Comm;
  string Start;
  string End;

  cin >> k >> n;
  while (n-- > 0)
  {
    cin >> Start;
    Comm.push_back(Start);
  }
  cin >> Start;
  cin >> End;

  string::iterator S, C;
  int x;

  while (!Start.empty())
  {
    S = Start.begin();
    x = Start.find(End[0]);
    if (x != -1)
      C = S + Start.find(End[0]);
    else
    {
      cout << "NO";
      return 0;
    }

    while (true)
    {
      if (S == C)
      {
        End.erase(End.begin());
        Start.erase(S);
        break;
      }
      if (InComm(*S, *C, Comm))
        S++;
      else
      {
        cout << "NO";
        return 0;
      }
    }
  }

  cout << "YES";
  return 0;
}