#include <cstdio>
#include <iostream>
#include <string>
#include <functional>

int k, n;
bool mat[10][10] {};
std::string s, t;
std::string *cur_string;

bool exists_path( int pos1, int pos2 )
{
  int dir = (pos1 > pos2 ? -1 : 1);
  for (int i = pos1; i != pos2; i += dir)
    if (!mat[(*cur_string)[pos1] - 'a'][(*cur_string)[i + dir] - 'a'])
      return false;
  return true;
}

bool rec( size_t pos )
{
  for (; pos < cur_string->size() && (*cur_string)[pos] == t[pos]; pos++)
    ;
  if (pos == cur_string->size())
    return true;

  for (size_t i = pos + 1; i < t.size(); i++)
    if ((*cur_string)[i] == t[pos] && exists_path(i, pos))
    {
      char save = (*cur_string)[i];
      memmove((char *)cur_string->data() + pos + 1, (char *)cur_string->data() + pos, i - pos);
      if (rec(pos + 1))
        return true;
      memmove((char *)cur_string->data() + pos, (char *)cur_string->data() + pos + 1, i - pos);
      ((char *)cur_string->data())[i] = save;
    }
  return false;
}

int main( void )
{
  std::cin >> k >> n;
  for (int i = 0; i < n; i++)
  {
    char a, b;
    std::cin >> a >> b;
    mat[a - 'a'][b - 'a'] = mat[b - 'a'][a - 'a'] = true;
  }

  s.reserve(100000);
  t.reserve(100000);
  std::cin >> s >> t;

  int ns[10] = {}, nt[10] = {};

  for (int i = 0; i < s.size(); i++)
    ns[s[i] - 'a']++, nt[t[i] - 'a']++;
  for (int i = 0; i < 10; i++)
    if (ns[i] != nt[i])
    {
      std::cout << "NO" << std::endl;
      return 0;
    }

  cur_string = &s;

  if (rec(0))
    std::cout << "YES" << std::endl;
  else
    std::cout << "NO" << std::endl;

  return 0;
}