#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

const int INF = 1000000000;

void f(int &a, int &b){
    if (a == 1 && b == 0){
        a = 0;
        b = 1;
    }
    else if (a == 0 && b == 1){
        a = -1;
        b = 0;
    }
    else if (a == -1 && b == 0){
        a = 0;
        b = -1;
    }
    else if (a == 0 && b == -1){
        a = 1;
        b = 0;
    }
}

int main(){
    int n, d, k;
    cin >> n >> d >> k;
    ++n;

    vector< pair<int, int> > arr;
    int x = 0, y = 0;
    int vX = 0, vY = 1;
    for (int i = 0; i < n;){
        for (int j = 0; j < d; ++j){
            arr.push_back(make_pair(x, y));
            ++i;
            x += vX;
            y += vY;
            if(i == n)
                break;
        }
        if(i == n)
            break;
        f(vX, vY);
        for (int j = 0; j < d; ++j){
            arr.push_back(make_pair(x, y));
            ++i;
            x += vX;
            y += vY;
            if(i == n)break;
        }
        f(vX, vY);
        d *= k;
    }
    int minX = INF, maxX = -INF, minY = INF, maxY = -INF;
    for (int i = 0; i < arr.size(); ++i){
        minX = min(minX, arr[i].first);
        maxX = max(maxX, arr[i].first);
        minY = min(minY, arr[i].second);
        maxY = max(maxY, arr[i].second);
    }
    int dX = maxX - minX + 1, dY = maxY - minY + 1;
    vector< vector<char> > ans(dX, vector<char>(dY, '.'));
    for (int i = 0; i < arr.size(); ++i){
        ans[arr[i].first - minX][arr[i].second - minY] = '*';
    }
    cout << ans.size() << " " << ans[0].size() << endl;
    for (int i = 0; i < ans.size(); ++i){
        for (int j = 0; j < ans[i].size(); ++j){
            cout << ans[i][j];
        }
        cout << endl;
    }
    return 0;
}
