#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

int gcd(int a, int b)
{
    if (a == 0 || b == 0)
    {
        return max(a, b);
    }
    if (a > b)
    {
        return gcd(b, a % b);
    }
    else
    {
        return gcd(a, b % a);
    }
}

int main()
{
    int n, k;
    cin >> n >> k;
    vector<int> a(n, 0);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
    }
    int cur = a[0];
    for (int i = 0; i < k; i++)
    {
        cur = gcd(cur, a[i]);
    }
    int ans = cur;
    for (int i = k; i < n; i++)
    {
        cur = gcd(gcd(a[i - 1], a[i]), cur * a[i - k]);
        ans = max(cur, ans);
    }

    cout << ans;
}
/*
10 4
2 3 4 8 12 6 12 18 4 3
*/
