#include <iostream>
#include <map>
#include <vector>
#include "math.h"

using namespace std;
vector<long long> massiv;
vector<long long> nod;
map<pair<int, int>, long long> old;

long long count(int a, int b, vector<vector<long long>> arr) {
    vector<long long> arr1(arr[a]);
    vector<long long> arr2(arr[b]);
    int i = 0;
    int j = 0;
    long long res = 1;
    while (i < arr1.size() && j < arr2.size()) {
        if (arr1[i] == arr2[j]) {
            res *= arr1[i];
            i++;
            j++;
        } else {
            if (arr1[i] > arr2[j])
                j++;
            else
                i++;
        }
    }
    return res;
}

long long countmas(int a, int b, vector<vector<long long>> arr) {
    if (a == b)
        return massiv[a];
    else {
        if (old[{a, b}] != 0)
            return old[{a, b}];
        else {
            long long h = min(countmas(a, (a + b) / 2, arr), countmas((a + b) / 2 + 1, b, arr));
            old[{a, b}] = h;
            return h;
        }
    }
}

int main() {
    int n, k, j;
    long long a;
    cin >> n >> k;
    long long max = 1;
    long long maxdel;
    long long prev = 1;
    vector<vector<long long>> arr(n);
    for (int i = 0; i < n; i++) {
        cin >> a;
        massiv.push_back(a);
        //maxdel = round(sqrt(a)) + 1;
        maxdel=a/2;
        j = 2;
        while (j <= maxdel) {
            if (a % j == 0) {
                arr[i].push_back(j);
                a /= j;
            } else
                j++;
        }
        if(arr[i].size()==0)
            arr[i].push_back(massiv[i]);
        if (i > 0) {
            nod.push_back(count(i - 1, i, arr));
            old[{i-1,i}]=nod[i-1];
            cout<<nod[i-1]<<" ";
        }
    }
    cout<<endl;
    max = countmas(0, k - 1, arr);
    for (int i = 1; i < n - k + 1; i++) {
        a = countmas(i, k - 1 + i,arr);
        if (a > max)
            max = a;
    }
    cout << max;
    return 0;
}