#include <iostream>
#include <map>
#include <vector>
#include "math.h"

using namespace std;
vector<long long> massiv;
map<pair<int, int>, vector<long long>> old;

vector<long long> count(int a, int b, vector<vector<long long>> arr) {
    vector<long long> arr1(arr[a]);
    vector<long long> arr2(arr[b]);
    int i = 0;
    int j = 0;
    vector<long long> res;
    while (i < arr1.size() && j < arr2.size()) {
        if (arr1[i] == arr2[j]) {
            res.push_back(arr1[i]);
            i++;
            j++;
        } else {
            if (arr1[i] > arr2[j])
                j++;
            else
                i++;
        }
    }
    if (res.size() == 0)
        res.push_back(1);
    return res;
}

vector<long long> countmas(int a, int b, vector<vector<long long>> arr) {
    if (a == b)
        return arr[a];
    else {
        if (old[{a, b}].size() != 0)
            return old[{a, b}];
        else {
            vector<long long> arr1 = countmas(a, (a + b) / 2, arr);
            vector<long long> arr2 = countmas((a + b) / 2 + 1, b, arr);
            int i = 0;
            int j = 0;
            vector<long long> res;
            while (i < arr1.size() && j < arr2.size()) {
                if (arr1[i] == arr2[j]) {
                    res.push_back(arr1[i]);
                    i++;
                    j++;
                } else {
                    if (arr1[i] > arr2[j])
                        j++;
                    else
                        i++;
                }
            }
            if (res.size() == 0)
                res.push_back(1);
            return res;
        }
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    long long n, k, j;
    long long a;
    cin >> n >> k;
    long long max = 1;
    vector<vector<long long>> arr(n);
    vector<long long> res;
    for (int i = 0; i < n; i++) {
        cin >> a;
        massiv.push_back(a);
        j = 2;
        while (j <= round(sqrt(a)) + 1) {
            if (a % j == 0) {
                arr[i].push_back(j);
                a /= j;
            } else
                j++;
        }
        if (a > 1)
            arr[i].push_back(a);
        if (i > 0) {
            old[{i - 1, i}] = count(i - 1, i, arr);
        }
    }
    res = countmas(0, k - 1, arr);
    for (int i = 0; i < res.size(); i++)
        max *= res[i];
    for (int i = 1; i < n - k + 1; i++) {
        res.clear();
        res = countmas(i, k - 1 + i, arr);
        a = 1;
        for (int i = 0; i < res.size(); i++)
            a *= res[i];
        if (a > max)
            max = a;
    }
    cout << max;
    return 0;
}