import java.util.*;
import java.io.*;

public class Main {
    FastScanner in;
    PrintWriter out;

    public void solve() {
        int k = in.nextInt(),
                n = in.nextInt();
        HashMap<Character, Character> l = new HashMap<>();
        char[][] mas = new char[k][2];
        for (int i = 0; i < n; i++) {
            char[] tmp = in.next().toCharArray();
            l.put(tmp[0], tmp[1]);
            mas[i][0] = tmp[0];
            mas[i][1] = tmp[1];
        }

        for (int i = 1; i < k; i++) {
            if (mas[i - 1][1] == mas[i][0]) {
                l.put(mas[i - 1][0], mas[i][1]);
            } else if (mas[i - 1][0] == mas[i][1]) {
                l.put(mas[i - 1][1], mas[i][0]);
            } else if (mas[i - 1][0] == mas[i][0]) {
                l.put(mas[i - 1][1], mas[i][1]);
            }
            else if (mas[i - 1][1] == mas[i][1]) {
                l.put(mas[i - 1][0], mas[i][0]);
            }

        }
        char[] s = in.next().toCharArray();
        char[] t = in.next().toCharArray();
        for (int i = 0; i < s.length; i++) {
            boolean b = false;
            if (s[i] != t[i]) {
                if (l.containsKey(s[i])) {
                    if (l.get(s[i]) == t[i])
                        b = true;
                } else if (l.containsValue(s[i])) {
                    if (l.get(t[i]) == s[i])
                        b = true;
                }
                if (!b) {
                    System.out.println("NO");
                    System.exit(0);
                }
            }

        }
        System.out.println("YES");
    }

    public void run() {
        in = new FastScanner(System.in);
        out = new PrintWriter(System.out);

        solve();

        out.close();
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(InputStream in) {
            br = new BufferedReader(new InputStreamReader(in));
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }
    }

    public static void main(String[] arg) {
        new Main().run();
    }
}