#include <iostream>
#include <set>
#include <algorithm>
#include <queue>
#include <vector>
#include <math.h>
using namespace std;

#define ll long long
#define vii vector<int>
#define pii pair<int, int>
#define ld long double
#define s second
#define f first
#define mp make_pair

ll gcd(ll a, ll b)
{
    if(b > a)
        swap(a, b);
    if(b == 0)
        return a;
    else
        return gcd(b, a % b);
}

int main()
{
    ll n, k;
    cin >> n >> k;
    vector<ll> a(n);
    for(ll i = 0; i < n; i++)
        cin >> a[i];

    ll x = log10(n) / log10(2);
    vector<vector<ll> > dp(n, vector<ll>(x + 1));

    for(ll i = 0; i < n; i++)
        dp[i][0] = a[i];

    int cur = 0;
    ll len;
    ll cnt = 0;
    for(len = 2; len <= k; len *= 2)
    {
        cur++;
        for(ll x = 0; x <= n - len; x++)
            dp[x][cur] = gcd(dp[x][cur - 1], dp[x + len / 2][cur - 1]);
    }

    if(len != k)
    {
        len /= 2;
        ll ost = k - len;

        ll x = log10(ost) / log10(2);
        ll f = pow(2, x);

        if(x > 0)
        {
            for(ll i = 0; i <= n - len - f; i++)
            {
               // cout << dp[i][cur] << " " << dp[i + len][x] << " " << i << endl;
                dp[i][cur] = gcd(dp[i][cur], dp[i + len][x]);
            }
            len += f;
        }

        if(len != k)
            for(int i = 0; i <= n - k; i++)
            {
                if(dp[i][cur] == 0)
                    break;
                for(int j = i + len; j < i + k; j++)
                {
                    dp[i][cur] = gcd(dp[i][cur], a[j]);
                }
            }
    }


    ll answ = 0;
    for(int i = 0; i <= n - k; i++)
        answ = max(answ, dp[i][cur]);
    cout << answ << endl;
    return 0;
}
