#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

unsigned long long int NOD(unsigned long long int a, unsigned long long int b)
{
	if (a == 1 || b == 1)
	{
		return 1;
	}
	if (a < b)
	{
		swap(a, b);
	}
	while (a && b)
	{
		swap(a, b);
		a = a % b;
	}

	return a + b;
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, k;
	cin >> n >> k;

	vector <unsigned long long int> arr(n);

	for (int i = 0; i < n; i++)
	{
		cin >> arr[i];
	}

	vector <unsigned long long int> nods(n - k + 1);
	
	vector <unsigned long long int> noks(n - k + 1);

	for (int i = 0; i < noks.size(); i++)
	{
		unsigned long long int nod = arr[i + 1];
		for (int j = 2; j < k; j++)
		{
			nod = NOD(nod, arr[i + j]);
		}
		noks[i] = arr[i] * nod / NOD(arr[i], nod);
		nods[i] = arr[i] * nod / noks[i];
	}

	/*nods[0] = arr[1];
	for (int i = 2; i < k; i++)
	{
		nods[0] = NOD(nods[0], arr[i]);
	}
	long long int nok = arr[0] * nods[0] / NOD(arr[0], nods[0]);
	nods[0] = NOD(arr[0], nods[0]);
	
	for (int i = 1; i < nods.size(); i++)
	{
		long long int b = nods[i - 1] * nok / arr[i - 1];
		nok = b * arr[i + k - 1] / NOD(b, arr[i + k - 1]);
		nods[i] = NOD(b, arr[i + k - 1]);
	}*/

	/*for (int i = 0; i < nods.size(); i++)
	{
		nods[i] = arr[i];
		for (int j = 1; j < k; j++)
		{
			nods[i] = NOD(nods[i], arr[i + j]);
		}
	}*/

	cout << *max_element(nods.begin(), nods.end());

	//system("pause");
	return 0;
}