import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class nC {

	public class Point {
		int x, y;

		public Point minUpd(Point a) {
			if (a.x < x) {
				x = a.x;
			}
			if (a.y < y) {
				y = a.y;
			}
			return this;
		}

		public Point maxUpd(Point a) {
			if (a.x > x) {
				x = a.x;
			}
			if (a.y > y) {
				y = a.y;
			}
			return this;
		}

		public Point clone() {
			Point p = new Point();
			p.x = x;
			p.y = y;
			return p;
		}
	}

	public void run() throws IOException {
		br = new BufferedReader(new InputStreamReader(System.in));
		pw = new PrintWriter(System.out);
		int n = nextInt();
		int d = nextInt();
		int k = nextInt();
		int sum = 0;
		ArrayList<Point> p = new ArrayList<Point>();
		Point a = new Point();
		a.x = 0;
		a.y = 0;
		p.add(a.clone());
		Point min = new Point();
		min.x = 0;
		min.y = 0;
		Point max = new Point();
		max.x = 0;
		max.y = 0;
		int vx = d;
		int vy = 0;
		while (sum < n) {
			if (vy == 0) {
				if (vx > 0) {
					for (int i = 0; i < vx && sum < n; i++, sum++) {
						a.x += 1;
						p.add(a.clone());
					}
				} else {
					for (int i = 0; i < -vx && sum < n; i++, sum++) {
						a.x += -1;
						p.add(a.clone());
					}
				}
			}else {
				if (vy > 0) {
					for (int i = 0; i < vy && sum < n; i++, sum++) {
						a.y += 1;
						p.add(a.clone());
					}
				} else {
					for (int i = 0; i < -vy && sum < n; i++, sum++) {
						a.y += -1;
						p.add(a.clone());
					}
				}
			}
			min = min.minUpd(a);
			max = max.maxUpd(a);
			int tmp = vy;
			vy = vx;
			vx = -tmp;
			
			if (vy == 0) {
				if (vx > 0) {
					for (int i = 0; i < vx && sum < n; i++, sum++) {
						a.x += 1;
						p.add(a.clone());
					}
				} else {
					for (int i = 0; i < -vx && sum < n; i++, sum++) {
						a.x += -1;
						p.add(a.clone());
					}
				}
			}else {
				if (vy > 0) {
					for (int i = 0; i < vy && sum < n; i++, sum++) {
						a.y += 1;
						p.add(a.clone());
					}
				} else {
					for (int i = 0; i < -vy && sum < n; i++, sum++) {
						a.y += -1;
						p.add(a.clone());
					}
				}
			}
			min = min.minUpd(a);
			max = max.maxUpd(a);
			tmp = vy;
			vy = vx;
			vx = -tmp;
			
			vx *= k;
			vy *= k;
			d *= k;
		}

		boolean[][] mat = new boolean[max.x - min.x + 1][max.y - min.y + 1];
		for (Point tmp : p) {
			mat[tmp.x - min.x][tmp.y - min.y] = true;
		}
		pw.println(mat[0].length + " " + mat.length);
		for (int i = mat[0].length - 1; i >=0; i--) {
			StringBuilder sb = new StringBuilder();
			for (int j = 0; j < mat.length; j++) {
				if (mat[j][i]) {
					sb.append('*');
				} else {
					sb.append('.');
				}
			}
			pw.println(sb.toString());
		}
		pw.close();
	}

	BufferedReader br;
	PrintWriter pw;
	StringTokenizer st;

	public String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public static void main(String[] args) throws IOException {
		new nC().run();
	}

}