#include <bits/stdc++.h>

using namespace std;

using ll = int64_t;
#define rep(i, n) for(int i = 0; i < n; i++)
#define vec_in(v) for(auto& i : v) cin >> i;
#define vec_out(v) for (int vector_out = 0; vector_out < v.size(); vector_out++) cout << v[vector_out] << " \n"[vector_out == v.size() - 1];

struct Queue {
    vector<pair<ll, ll>> stack, stack1;

    void add(ll x) {
        if (stack.empty()) stack.push_back({x, x});
        else stack.push_back({x, __gcd(x, stack.back().second)});
    }

    void pop() {
        if (!stack1.empty()) {
            stack1.pop_back();
            return;
        }
        stack1.push_back({stack.back().first, stack.back().first});
        stack.pop_back();
        while (!stack.empty()) {
            stack1.push_back({stack.back().first, __gcd(stack.back().first, stack1.back().second)});
            stack.pop_back();
        }
        stack1.pop_back();
    }

    ll gcd() {
        if (stack.empty() && stack1.empty()) assert(0);
        if (stack.empty()) return stack1.back().second;
        if (stack1.empty()) return stack.back().second;
        return __gcd(stack.back().second, stack1.back().second);
    }
};

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    int n, k;
    cin >> n >> k;
    vector<ll> arr(n);
    vec_in(arr);
    Queue q;
    for (int i = 0; i < k; i++) q.add(arr[i]);
    ll ans = q.gcd();
    for (int i = k; i < n; i++){
        q.pop();
        q.add(arr[i]);
        ans = max(q.gcd(), ans);
    }
    
    cout << ans << '\n';
}