#include <iostream>
#include <vector>

using namespace std;

void step(int x, int y, int* dir, int dest, int d, int* cor_x, int* cor_y, int j) {
    int xStep = dir[2 * dest];
    int yStep = dir[2 * dest + 1];
    for (int i = 0; i < d; i++) {
        x += xStep;
        y += yStep;
        cor_x[j] = x;
        cor_y[j] = y;
        j++;

    }
}

int main(void) {
    int n, d, k, nn;
    int p[] = {1, 0, 0, -1, -1, 0, 0, 1};
    int* dir = p;
    cin >> n >> d >> k;
    nn = n + 1;
    int* cor_x = new int[nn];
    int* cor_y = new int[nn];
    cor_x[0] = 0;
    cor_y[0] = 0;
    int x = 0, y = 0, dest = 0;
    int f = 1;
    while (n > 0 && f < nn) {
        step(x, y, dir, dest, min(d, n), cor_x, cor_y, f);
        if (n > 0)
            f += min(n, d);
        else
            f = nn;n -= d;

        f--;
        x = cor_x[f];
        y = cor_y[f];
        dest += 1;
        dest %= 4;
        f++;
        if (n > 0 && f < nn) {
            step(x, y, dir, dest, min(d, n), cor_x, cor_y, f);
            if (n > 0)
                f += min(n, d);
            else
                f = nn;n -= d;

            f--;
            x = cor_x[f];
            y = cor_y[f];
            dest += 1;
            dest %= 4;
            f++;
        }

        d *= k;
    }
    int min_x = 1000000000, min_y = 1000000000, max_x = -1000000000, max_y = -1000000000;
    for (int i = 0; i < nn; i++) {
        x = cor_x[i];
        y = cor_y[i];
        min_x = min(min_x, x);
        min_y = min(min_y, y);
        max_x = max(max_x, x);
        max_y = max(max_y, y);
    }
    //for (int i = 0; i < nn; i++)
     //   cout << cor_x[i] << " " << cor_y[i] << endl;
    int h = max_y - min_y + 1, w = max_x - min_x + 1;
    bool** steps = new bool*[h];
    for (int i = 0; i < h; i++)
        steps[i] = new bool[w];
    for (int i = 0; i < h; i++)
        for (int j = 0; j < w; j++)
            steps[i][j] = false;
    for (int i = 0; i < nn; i++) {
        x = cor_x[i];
        y = cor_y[i];
        steps[y - min_y][x - min_x] = true;
    }
    cout << h << " " << w << endl;
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            if (steps[i][j])
                cout << "*";
            else
                cout << ".";
        }
    cout << endl;
    }
    return 0;
}
