#include <cstdio>
#include <iostream>

int main( void )
{
  int n, d, k;
  std::cin >> n >> d >> k;
  int coords[1000][2] = {{0, 0}};
  int steps = 1, i = 0;
  int dirs[4][2] =
  {
    {1, 0},
    {0, 1},
    {-1, 0},
    {0, -1}
  }, cur_dir = 0;
  int minx = 0, maxx = 0, miny = 0, maxy = 0;
  while (steps < n + 1)
  {
    bool to_break = false;
    int num = d;
    if (steps + d >= n + 1)
      to_break = true, num = n + 1 - steps;

    for (int i = 0; i < num; i++, steps++)
    {
      coords[steps][0] = coords[steps - 1][0] + dirs[cur_dir][0];
      coords[steps][1] = coords[steps - 1][1] + dirs[cur_dir][1];
      if (coords[steps][0] > maxx)
        maxx = coords[steps][0];
      if (coords[steps][0] < minx)
        minx = coords[steps][0];
      if (coords[steps][1] > maxy)
        maxy = coords[steps][1];
      if (coords[steps][1] < miny)
        miny = coords[steps][1];
    }
    if (to_break)
      break;

    if (i++ % 2 == 1)
      d *= k;
    cur_dir = (cur_dir + 1) % 4;
  }

  int w = maxx - minx + 1, h = maxy - miny + 1;
  std::cout << w << " " << h << std::endl;

  char *pole = new char[w * h];
  memset(pole, '.', w * h);

  for (int i = 0; i <= n; i++)
    pole[(coords[i][1] - miny) * w + coords[i][0] - minx] = '*';
  for (int i = h - 1; i >= 0; i--)
  {
    for (int j = 0; j < w; j++)
      std::cout << pole[i * w + j];
    std::cout << std::endl;
  }
  delete[] pole;
  return 0;
}