#include <iostream>
#include <algorithm>
#include <vector>

#define ulint unsigned long int
using namespace std;

void makeMove (ulint& currX, ulint& currY, unsigned short int direction, ulint step, vector<vector<char>>& map, ulint& moves)
{
  ulint x = currX, y = currY;
  switch (direction)
  {
  case 0:
    for (; currX < x + step; currX++)
    {
        map[currY][currX] = '*';
        moves++;
    };
    break;
  case 1:
    for (; currY > y - step; currY--)
    {
      map[currY][currX] = '*';
      moves++;
    };
    break;
  case 2:
    for (; currX > x - step; currX--)
    {
      map[currY][currX] = '*';
      moves++;
    };
    break;
  case 3:
    for (; currY < y + step; currY++)
    {
      map[currY][currX] = '*';
      moves++;
    }
    break;
  default:
    break;
  }
}

int main()
{
     unsigned int n, k;
     ulint d;
     cin >> n >> d >> k;
     
     vector<vector<char>> map (2*n + 2*d, vector<char> (2*n + 2*d, '.'));
/*     for (ulint i = 0 ; i < 2*n; i++)
     {
        for (ulint j = 0; j < 2*n; j++)
          cout << map[i][j];
        cout << endl;
     };
*/

     ulint currentPosX = n + d;
     ulint currentPosY = n + d;
     ulint beginX = currentPosX, beginY = currentPosY, endX = currentPosX, endY = currentPosY;
     ulint moves = 0;
     unsigned short int direction = 0; //0 - right, 1 - up, 2 - left, 3 - down
     while (moves <= n + 1)
     {
        makeMove(currentPosX, currentPosY, direction % 4, min(d, n + 1 - moves), map, moves);
        direction++;
        if (direction > 1 && direction % 2 == 0)
           d *= k;
        beginX = min(currentPosX, beginX);
        endX   = max(currentPosX, endX);
        beginY = min(currentPosY, beginY);
        endY   = max(currentPosY, endY);
        if (moves == n + 1)
        {
          if (currentPosX == endX)
            endX--;
          break;
        }
     };
     cout << endY - beginY + 1 << " " << endX - beginX + 1<< endl;
     for (ulint i = beginY ; i <= endY; i++)
     {
       for (ulint j = beginX; j <= endX; j++)
         cout << map[i][j];
       cout << endl;
     };
    // system("pause");
     return 0;
}