#include <iostream>
#include <vector>

using namespace std;

int main() {
    unsigned int n, d, k;

    cin >> n >> d >> k;

    vector<vector<char>> field(n * 2 + 1, vector<char>(n * 2 + 1, '.'));

    int x = n, y = n, xLeft = n, xRight = n, yUp = n, yDown = n, coord = 0;

    field[x][y] = '*';

    for (int i = 0; i < n; coord = (coord + 1) % 4) {
        if (coord == 0) {
            for (int j = 0; j < d && i < n; j++, i++) {
                field[y][++x] = '*';
                xRight = max(xRight, x);
            }
        }
        if (coord == 1) {
            for (int j = 0; j < d && i < n; j++, i++) {
                field[--y][x] = '*';
                yUp = min(yUp, y);
            }
        }
        if (coord == 2) {
            d *= k;
            for (int j = 0; j < d && i < n; j++, i++) {
                field[y][--x] = '*';
                xLeft = min(xLeft, x);
            }
        }
        if (coord == 3) {
            for (int j = 0; j < d && i < n; j++, i++) {
                field[++y][x] = '*';
                yDown = max(yDown, y);
            }
        }
    }

    cout << xRight - xLeft + 1 << ' ' << yDown - yUp + 1 << endl;

    for (int i = yUp; i <= yDown; i++) {
        for (int j = xLeft; j <= xRight; j++) {
            cout << field[i][j];
        }
        cout << endl;
    }

    return 0;
}