#include <iostream>

using namespace std;

long long min(long long a, long long b){
    return a < b ? a : b;
}
long long max(long long a, long long b){
    return a > b ? a : b;
}
long long gcd(long long a, long long b){
    if (a == 0){
        return b;
    }
    return gcd(max(a,b) - min(a,b), a);
}

long long arrGcd(long long arr[], int start, int length){
    long long res = gcd(arr[start], arr[start + 1]);
    for (int i = start + 2; i < start + length; i++){
        res = gcd(res, arr[i]);
    }
    return res;
}
int main()
{
    int _max = 0;
    int n,k;
    cin >> n >> k;
    long long arr[n];
    for (int i = 0; i < n; i++){
        cin >> arr[i];
    }
    for (int i = 0; i < n - k + 1; i++){
        long long local = arrGcd(arr,i,k);
        if (_max < local){
            _max = local;
        }
    }
    cout << _max << endl;
    return 0;
}
