#include <iostream>

using namespace std;

long long a[101];

long long gcd(long long a, long long b)
{
    if (a == 0 || b == 0) return a+b;
    else gcd(b, a%b);
}

long long gcdK(int x, int k)
{
    long long ans = a[x];
    for (int i = x+1; i < x+k; i++)
        ans = gcd(ans, a[i]);
    return ans;
}


int main()
{
    int n, k;
    cin >> n >> k;

    for (int i = 0; i < n; i++) cin >> a[i];

    long long ans = -1;
    for (int i = 0; i < n-k+1; i++)
    {
       // cout <<i << ' ' <<  gcdK(i, k) << endl;
        ans = max(ans, gcdK(i, k));
    }

    cout << ans;
}
/*
5 4
2 8 32 128 256
*/
