#include <iostream>
using namespace std;


int main() {
    int h; int w;

    long long n, d, k;
    cin >> n >> d >> k;

    pair<int, int> pos = make_pair(999, 999);
    bool pool[2000][2000];

    for (int i = 0; i < 2000; i++) {
        for (int j = 0; j < 2000; j++) {
            pool[i][j] = false;
        }
    }
    pool[pos.first][pos.second] = true;

    int minX = 2000;
    int minY = 2000;
    int maxX = -1;
    int maxY = -1;
    int turn  = 0;

    while(n != 0) {
        if (turn == 0) {
            for (int i = 1; i <= d; i++) {
                if (n == 0)
                    break;
                else {
                    n--;
                    pool[pos.first][pos.second+1] = true;
                    pos.second++;
                    maxX = max(maxX, pos.second);
                    minX = min(minX, pos.second);
                    maxY = max(maxY, pos.first);
                    minY = min(minY, pos.first);
                }
            }
            for (int i = 1; i <= d; i++) {
                if (n == 0) {
                    break;
                }
                else {
                    n--;
                    pool[pos.first+1][pos.second] = true;
                    pos.first++;
                    maxX = max(maxX, pos.second);
                    minX = min(minX, pos.second);
                    maxY = max(maxY, pos.first);
                    minY = min(minY, pos.first);
                }
            }
            turn += 2;
        }
        else if (turn == 2) {
            for (int i = 1; i <= d; i++) {
                if (n == 0)
                    break;
                else {
                    n--;
                    pool[pos.first][pos.second-1] = true;
                    pos.second--;

                    maxX = max(maxX, pos.second);
                    minX = min(minX, pos.second);
                    maxY = max(maxY, pos.first);
                    minY = min(minY, pos.first);
                }
            }
            for (int i = 1; i <= d; i++) {
                if (n == 0) {
                    break;
                }
                else {
                    n--;
                    pool[pos.first-1][pos.second] = true;
                    pos.first--;
                    maxX = max(maxX, pos.second);
                    minX = min(minX, pos.second);
                    maxY = max(maxY, pos.first);
                    minY = min(minY, pos.first);
                }
            }
            turn = 0;
        }
        d = d*k;
    }

    w = maxX - minX + 1;
    h = maxY - minY + 1;
    cout << h << " " << w << endl;
    for (int i = maxY; i >= minY; i--) {
        for (int j = minX; j <= maxX; j++) {
            if (pool[i][j]) {
                cout << '*';
            }
            else
                cout << '.';
        }
        cout << endl;
    }
}
